/* CC layer positioning Extensions
   Modified: 2000.02.04
     by Henrik Vglin (hvaglin@yahoo.com)
   for Comic Creation site project [ http://www.freecfm.com/c/ccreation ]

   This Distribution is distributed under the terms of the GNU LGPL license.

   Requirements:
	dynapi.api [dynlayer, dyndocument],for sliding: dynapi.util [thread, pathanim]
 */

DynLayer.prototype.getPosInParent=function(pos,marginX,marginY) {

// FIRST MAKE SURE WE HAVE SOME VALUES

if (!pos) pos = 'middlecenter';
if (!marginX) marginX = 0;
if (!marginY) marginY = 0;

// DEFINE THE X AND Y POSITION

switch (pos) {

   // THE TOP OF THE PARENT (WITH A OPTIONAL MARGIN)

   case 'top': 
	posX=this.getX();
        posY=marginY;
	break;

   case 'topleft': 
	posX=marginX;
        posY=marginY;
	break;

   case 'topcenter': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2); 
	posY=marginY;
	break;

   case 'topright': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=marginY;
	break;

   // THE MIDDLE OF THE PARENT (WITH A OPTIONAL MARGIN)

   case 'middle': 
	posX=this.getX()+marginX;
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2)-marginY;
	break;

   case 'middleleft': 
	posX=0+marginX;
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2)-marginY;
	break;

   case 'middlecenter': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2);
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2);
	break;

   case 'middleright': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2)-marginY;
	break;

   // THE BOTTOM OF THE PARENT (WITH A OPTIONAL MARGIN)

   case 'bottom': 
	posX=this.getX()+marginX;
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   case 'bottomleft': 
	posX=0+marginX;
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   case 'bottomcenter': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2);
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   case 'bottomright': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   // ALIGNING HORIZONTALY IN PARENT (WITH A OPTIONAL MARGIN)

   case 'left': 
	posX=0+marginX;
        posY=this.getY()-marginY;
	break;

   case 'center': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2);
        posY=this.getY()-marginY;
	break;

   case 'right': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=this.getY()-marginY;
	break;

   default: 	posX=this.getX(); posY=this.getY();

   }

}

DynLayer.prototype.positionInParent=function(pos,marginX,marginY,slide,slideBy,slideSpeed) {

this.doPos = function() { eval(this+".positionInParent('"+pos+"',"+marginX+","+marginY+","+slide+","+slideBy+","+slideSpeed+")") }; 

this.getPosInParent(pos,marginX,marginY) 

if (slide) {
   if (!slideBy) slideBy = 10;
   if (!slideSpeed) slideSpeed = 20;
   this.slideTo(posX,posY,slideBy,slideSpeed)
   } else {
   this.moveTo(posX,posY);
   }

}

DynLayer.prototype.getPosAtLyr=function(othLyr,pos,marginX,marginY) {

// FIRST MAKE SURE WE HAVE SOME VALUES

if (!pos) pos = 'middlecenter';
if (!marginX) marginX = 0;
if (!marginY) marginY = 0;

// DEFINE THE X AND Y POSITION

var left=othLyr.getX()-this.getWidth()-marginX;
var center=othLyr.getX()+(othLyr.getWidth()/2)-(this.getWidth()/2);
var right=othLyr.getX()+othLyr.getWidth()+marginX;

var top=othLyr.getY()-this.getHeight()-marginY;
var middle=othLyr.getY()+(othLyr.getHeight()/2)-(this.getHeight()/2)-marginY;
var bottom=othLyr.getY()+othLyr.getHeight()+marginY;


switch (pos) {

   // AGAINST THE OTHER LAYER'S TOP BORDERS (WITH A OPTIONAL MARGIN)

   case 'top': 
	posX=this.getX();
        posY=top;
	break;

   case 'topleft': 
	posX=left;
        posY=top;
	break;

   case 'topcenter': 
	posX=center; 
	posY=top;
	break;

   case 'topright': 
	posX=right;
        posY=top;
	break;

   // AGAINST THE OTHER LAYER'S MIDDLE BORDERS (WITH A OPTIONAL MARGIN)

   case 'middle': 
	posX=this.getX()+marginX;
        posY=middle;
	break;

   case 'middleleft': 
	posX=left;
        posY=middle;
	break;

   case 'middlecenter': 
	posX=center;
        posY=othLyr.getY()+(othLyr.getHeight()/2)-(this.getHeight()/2);
	break;

   case 'middleright': 
	posX=right;
        posY=middle;
	break;

   // AGAINST THE OTHER LAYER'S BOTTOM BORDERS (WITH A OPTIONAL MARGIN)

   case 'bottom': 
	posX=this.getX()+marginX;
        posY=bottom;
	break;

   case 'bottomleft': 
	posX=left;
        posY=bottom;
	break;

   case 'bottomcenter': 
	posX=center;
        posY=bottom;
	break;

   case 'bottomright': 
	posX=right;
        posY=bottom;
	break;

   // ALIGNING AGAINST THE OTHER LAYER'S HORIZONTAL BORDERS (WITH A OPTIONAL MARGIN)

   case 'left': 
	posX=left;
        posY=this.getY()-marginY;
	break;

   case 'center': 
	posX=center;
        posY=this.getY()-marginY;
	break;

   case 'right': 
	posX=right;
        posY=this.getY()-marginY;
	break;

   default: 	posX=this.getX(); posY=this.getY();

   }

}

DynLayer.prototype.positionAtLyr=function(othLyr,pos,marginX,marginY,slide,slideBy,slideSpeed) {

this.doPos = function() { eval(this+".positionAtLyr("+othLyr+",'"+pos+"',"+marginX+","+marginY+","+slide+","+slideBy+","+slideSpeed+")") }; 

this.getPosAtLyr(othLyr,pos,marginX,marginY)

if (slide) {
   if (!slideBy) slideBy = 10;
   if (!slideSpeed) slideSpeed = 20;
   this.slideTo(posX,posY,slideBy,slideSpeed)
   } else {
   this.moveTo(posX,posY);
   }
}

DynLayer.prototype.setPersistPos = function(b) {
	this.persistPos=b
	if (b==false) {
	this.posListener = new EventListener(this.parent);
	this.posListener.onmove = this.posListener.onscroll = this.posListener.onresize =  function(e) {
		this.doPos();	
		};
	this.addEventListener(this.posListener);
	}
	else {
		this.removeEventListener(this.posListener);
	}
};
