/* CC layer positioning Extensions
   Modified: 2000.02.04
     by Henrik Vglin (hvaglin@yahoo.com)
   for Comic Creation site project [ http://www.freecfm.com/c/ccreation ]

   This Distribution is distributed under the terms of the GNU LGPL license.

   Requirements:
	dynapi.api [dynlayer, dyndocument],for sliding: dynapi.util [thread, pathanim]
 */

DynLayer.prototype.getPosInParent=function(pos,marginX,marginY) {

// FIRST MAKE SURE WE HAVE SOME VALUES

if (!pos) pos = 'middlecenter';
if (!marginX) marginX = 0;
if (!marginY) marginY = 0;

// DEFINE THE X AND Y POSITION

switch (pos) {

   // THE TOP OF THE PARENT (WITH A OPTIONAL MARGIN)

   case 'top': 
	posX=this.getX();
        posY=marginY;
	break;

   case 'topleft': 
	posX=marginX;
        posY=marginY;
	break;

   case 'topcenter': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2); 
	posY=marginY;
	break;

   case 'topright': 
	posX=this.parent.getWidth()-(this.getWidth()-marginX);
        posY=marginY;
	break;

   // THE MIDDLE OF THE PARENT (WITH A OPTIONAL MARGIN)

   case 'middle': 
	posX=this.getX()+marginX;
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2)-marginY;
	break;

   case 'middleleft': 
	posX=0+marginX;
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2)-marginY;
	break;

   case 'middlecenter': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2);
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2);
	break;

   case 'middleright': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=(this.parent.getHeight()/2)-(this.getHeight()/2)-marginY;
	break;

   // THE BOTTOM OF THE PARENT (WITH A OPTIONAL MARGIN)

   case 'bottom': 
	posX=this.getX()+marginX;
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   case 'bottomleft': 
	posX=0+marginX;
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   case 'bottomcenter': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2);
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   case 'bottomright': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=this.parent.getHeight()-this.getHeight()-marginY;
	break;

   // ALIGNING HORIZONTALY IN PARENT (WITH A OPTIONAL MARGIN)

   case 'left': 
	posX=0+marginX;
        posY=this.getY()-marginY;
	break;

   case 'center': 
	posX=(this.parent.getWidth()/2)-(this.getWidth()/2);
        posY=this.getY()-marginY;
	break;

   case 'right': 
	posX=this.parent.getWidth()-this.getWidth()-marginX;
        posY=this.getY()-marginY;
	break;

   default: 	posX=this.getX(); posY=this.getY();

   }

}

DynLayer.prototype.positionInParent=function(pos,marginX,marginY,slide,slideBy,slideSpeed) {

this.getPosInParent(pos,marginX,marginY) 

if (slide) {
   if (!slideBy) slideBy = 10;
   if (!slideSpeed) slideSpeed = 20;
   this.slideTo(posX,posY,slideBy,slideSpeed)
   } else {
   this.moveTo(posX,posY);
   }

}

